/**
 * Created by By whh on 2018.3.29.
 * 被wanghh改的面目全非
 */
import React from 'react';
import {Button} from 'antd-mobile';
import classnames from 'classnames';
import YYIcon from './../icon/YYIcon';
import './YYButton.css';
import {isFunction} from '../../utils/FunctionUtil';

class YYButton extends React.Component {
    onHandleClick = (e) => {
        if (isFunction(this.props.onClick)) {
            this.props.onClick(e);
        }
    }
    render() {
        let {uititle, type, size, disabled, visible, onClick, inline, loading,icon, radius, wingBlank, children, className, offline,parentType,uiorigin,RunInDesign,uitype,uikey,nid,control_event,findUI,...restProps} = this.props;
        let wrapClz = classnames('yy-button', (!radius&&'yy-button-no-radius'), (wingBlank&&'yy-button-wing-blank'),(!visible&&'hidden'), className);
        let iconCom = icon?<YYIcon type={icon}/>:null;
        return (
            <Button {...restProps}
                    className={wrapClz}
                    type={type}
                    size={size}
                    disabled={disabled}
                    inline={inline}
                    loading={loading}
                    icon={iconCom}
                    onClick={this.onHandleClick}
            >
                {uititle||children}
            </Button>
        )
    }
}
YYButton.defaultProps = {
    uititle:null,//界面设计器中使用，替代children
    type:null,
    size:'large',
    disabled:false,
    visible:true,
    inline:false,
    onClick:null,
    loading:false,
    icon:"",
    radius:true,
    wingBlank:false,
    //设计器需要的props,不添加会warning
    offline:false,
    parentType:'',
    uiorigin:'',
    RunInDesign:false,
    uitype:'',
    uikey:'',
    nid:'',
    control_event:{},
    findUI:''
}
export default YYButton;