import classnames from 'classnames';
import React, {PureComponent} from 'react'
import {Flex} from 'antd-mobile'

export default class YYFlexItem extends PureComponent {

    static defaultProps = {
        prefixCls: 'yy-flex'
    };

    render() {
        const {prefixCls, className, children, basis, ...restProps} = this.props;
        const wrapCls = classnames(`${prefixCls}-item`, className);
        const flexStyle = {};
        if(basis){
            flexStyle['flexBasis'] = basis;
        }
        return (
            <Flex.Item className={wrapCls} style={flexStyle} {...restProps}>
                {children}
            </Flex.Item>
        )
    }
}
