import React, {Component} from 'react';
import {List} from 'antd-mobile';
import classnames from 'classnames';
import  './YYListItem.less';

class YYListItem extends Component {
  render() {
    let {size,arrow,disabled,RunInDesign,className,wrap,showBorder,multipleLine,title,titleExtra,leftFontMode,rightFontMode,visible,style,rightFontType,children} = this.props;
   let leftclass=leftFontMode?"yy-listitem-leftmode":""
   let rightclass=rightFontMode?"yy-listitem-rightmode":""
   let  borderClass=!showBorder?"yy-listitem-noborder":""
   let rightFontClass = `yy-listitem-${rightFontType}`;
   let  sizeClass="yy-listitem-"+size;
   let wrapClz = classnames('yy-listitem '+rightclass+" "+leftclass+" "+borderClass+" "+sizeClass+' '+rightFontClass , (!visible&&'hidden'),className);
    return (
       <List.Item
        multipleLine={multipleLine}
        extra={titleExtra&&titleExtra!=""?titleExtra:undefined}
        wrap={wrap}
        disabled={disabled}
        className={wrapClz}
        arrow={arrow}
        style={style}
        onClick={this.onClick.bind(this)}
       >
       {title}{children&&children.length&&<div className="yy-extra">{children}</div>}
       </List.Item>
    );
  }
  onClick(){
  	if(this.props.onClick){
  		  this.props.onClick();
  	}
  }
}
YYListItem.defaultProps = {
  visible: true,
  rightFontType: 'right'
}
export default YYListItem;