var UrlUtils = require('../../utils/UrlUtils');
var {FormApi,EditTableApi} = require('./api.all');
//系统预置的动作
var DefaultActions = {
    //跳转页面
    gotoPage:function(options){
        var {event,action,ui} = options;
        var {appCode,pageCode} = action;
        var viewUrl = UrlUtils.fillUrlParams('#/pages/view/{appCode}/{pageCode}',{
            appCode : appCode,
            pageCode : pageCode
        });
        window.open(viewUrl,'_self');
    },
    //表单保存
    formSave:function(options){
        var {event,action,ui} = options;
        var {storeKey} = action;
        if(storeKey){
            FormApi.saveData(this,{storeKey});
        }
    },
    //表单删除
    formDelete:function(options){
        var {event,action,ui} = options;
        var {storeKey} = action;
        if(storeKey){
            FormApi.deleteData(this,{storeKey});
        }
    },
    //编辑表格-增行
    editTableAddRow:function(options){
        var {event,action,ui} = options;
        var {editTableKey} = action;
        if(editTableKey){
            EditTableApi.addRow(this,editTableKey);
        }
    },
    //编辑表格-减行
    editTableDelRow:function(options){
        var {event,action,ui} = options;
        var {editTableKey} = action;
        if(editTableKey){
            EditTableApi.delRow(this,editTableKey);
        }
    }
};

module.exports = DefaultActions;