var React = require('react');
var _ = require('lodash');
var ajax = require('../../utils/ajax');
var {ADDR} = require('../../common/RestUrl');
var BaseWeb = ADDR+"/icop-elasticsearch-web";
var EsStore = {
    //存储元数据
    saveMetadata:function (options) {
        var {index,type,metadataModel} = options
        ajax.postJSON(BaseWeb+'/setMetadata', {index,type,metadataModel},success,error);
    },
    //存储数据
    save:function(options){
        var {index,type,data,success,error,refresh} = options;
        ajax.postJSON(BaseWeb+'/elasticsearch/index',{index,type,doc:data,refresh:refresh?refresh:true}, success, error);
    },
    //批量存储数据
    batchSave:function(options){
        var {index,type,data,success,error,refresh} = options;
        ajax.postJSON(BaseWeb+'/elasticsearch/multiIndex',{index,type,docList:data,refresh:refresh?refresh:true}, success, error);
    },
    //更新数据
    update:function(options){
        var {index,type,id,data,success,error,refresh} = options;
        ajax.postJSON(BaseWeb+'/elasticsearch/update',{index,type,id,doc:data,refresh:refresh?refresh:true}, success, error);
    },
    //获取单个数据
    getOne:function (options) {
        var {index, type, id, success, error} = options;
        ajax.postJSON(BaseWeb+'/elasticsearch/get',{index,type,id},success,error);
    },
    //删除单个数据
    deleteOne:function(options){
        var {index,type,id,success,error,refresh} = options;
        ajax.delJSON(BaseWeb+'/elasticsearch/delete',{index,type,id,refresh:refresh?refresh:true},success,error);
    },
    //删除多个数据
    deleteBatch:function(options){
        var {index,type,ids,success,error,refresh} = options;
        ajax.delJSON(BaseWeb+'/elasticsearch/multiDelete',{index,type,ids,refresh:refresh?refresh:true},success,error);
    },
    //依据条件查询唯一的单个数据
    findOne:function (options) {
        var { index, type,simpleCriteria, orderRules,success, error} = options;
        ajax.postJSON(BaseWeb+'/elasticsearch/filterForObject',{index,type,simpleCriteria, orderRules}, success, error);
    },
    //分页查询数据
    queryList:function(options){
        var {index,type,pageNumber,pageSize,searchText,simpleCriteria, orderRules,success,error} = options;
        ajax.postJSON(BaseWeb+'/elasticsearch/filterForPage',{index,type,pageNumber,pageSize,searchText,simpleCriteria, orderRules}, success, error);
    },
    //查询全部数据
    queryAll:function(options){
        var { index, type,searchText,simpleCriteria, orderRules, success, error} = options;
        ajax.postJSON(BaseWeb+'/elasticsearch/filterForList',{ index, type, searchText,simpleCriteria, orderRules}, success, error);
    }
};
module.exports=EsStore;