import React from 'react'
import {Tag} from 'antd-mobile'
import YYIcon from './../icon/YYIcon';
import classnames from 'classnames';


export default class YYTag extends React.Component {
	onChange(selected){
		this.props.onChange&&this.props.onChange(selected);
	}
	onClose(){
		this.props.onClose&&this.props.onClose();
	}
	afterClose(){
		this.props.afterClose&&this.props.afterClose();
	}
    render(){
    	let  {content,className,visible,...restProps}=this.props;
    	let areaClz = classnames('yy-tag',(!visible&&'hidden'), className);
        return(
            <Tag  className={areaClz}  {...restProps}  onChange={this.onChange.bind(this)} onClose={this.onClose.bind(this)} afterClose={this.afterClose.bind(this)}>
            {content}
            </Tag>
        )

    }
}

YYTag.defaultProps = {
   small:false,
   disabled:false,
   closable:false,
   selected:false,
   visible: true,
};
