'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.loadCSS = loadCSS;
exports.loadJS = loadJS;
exports.loadScripts = loadScripts;
exports.loadStyles = loadStyles;

var _getWebRoot = function _getWebRoot() {
    var curWwwPath = window.document.location.href;
    var pathName = window.document.location.pathname;
    var pos = curWwwPath.indexOf(pathName);
    var localhostPaht = curWwwPath.substring(0, pos);
    var projectName = pathName.substring(0, pathName.substr(1).indexOf('/') + 1);
    var contPath = localhostPaht + projectName;
    return contPath;
};

function loadCSS(src, onloadCss, basePath) {
    window.location.toString().substring(0, 1);
    if (!src || src.length == 0) return;
    var link = document.createElement('link');
    if (basePath && basePath.length > 0) {
        link.href = basePath + src;
    } else {
        link.href = src;
    }
    link.rel = 'stylesheet';
    if (onloadCss) link.onload = onloadCss;
    document.head.appendChild(link);
}

function loadJS(src, onloadScript, basePath) {
    if (!src || src.length == 0) return;
    var script = document.createElement('script');
    script.src = src;
    if (basePath && basePath.length > 0) {
        script.src = basePath + src;
    } else {
        script.src = src;
    }
    script.type = 'text/javascript';
    if (onloadScript) script.onload = onloadScript;
    document.head.appendChild(script);
}

function loadScripts(srcs, onloaded, basePath) {
    if (srcs) {
        if (srcs.length > 1) {
            var src = srcs.shift();
            loadJS(src, function () {
                loadScripts(srcs, onloaded, basePath);
            }, basePath);
        } else if (srcs.length == 1) {
            var src = srcs.shift();
            loadJS(src, onloaded, basePath);
        }
    }
}

function loadStyles(srcs, onloaded, basePath) {
    if (srcs) {
        if (srcs.length > 1) {
            var src = srcs.shift();
            loadCSS(src, function () {
                loadStyles(srcs, onloaded, basePath);
            }, basePath);
        } else if (srcs.length == 1) {
            var src = srcs.shift();
            loadCSS(src, onloaded, basePath);
        }
    }
}