'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _toast = require('antd-mobile/lib/toast');

var _toast2 = _interopRequireDefault(_toast);

exports.getMAJSON = getMAJSON;
exports.getICOPJSON = getICOPJSON;
exports.getICOPJSON2 = getICOPJSON2;
exports.postMAJSON = postMAJSON;
exports.postMAJSON2 = postMAJSON2;
exports.postICOPJSON = postICOPJSON;
exports.postICOPText = postICOPText;
exports.postICOPForm = postICOPForm;
exports.postNoAuth = postNoAuth;

require('antd-mobile/lib/toast/style/css');

var _superagent = require('superagent');

var _superagent2 = _interopRequireDefault(_superagent);

var _ajax = require('./ajax');

var _ajax2 = _interopRequireDefault(_ajax);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getMAJSON(url, data, success, error) {
    _ajax2.default.getText(url, data, function (data) {
        var data = JSON.parse(data);
        if (data.flag && data.flag == '0') {
            if (typeof success == 'function') {
                success(data.data);
            } else {
                console.log(data.data);
                _toast2.default.success(res.text, 1);
            }
        } else {
            if (typeof error == 'function') {
                error(data);
                _toast2.default.info(data.desc, 1);
            } else {
                _toast2.default.info(data.desc, 1);
            }
        }
    }, error);
}
function getICOPJSON(url, data, success, error) {
    _ajax2.default.getJSON(url, data, function (data) {
        if (data.success && data.success == true) {
            if (typeof success == 'function') {
                success(data.backData);
            } else {
                console.log(data.backData);
                _toast2.default.success(data.backMsg, 1);
            }
        } else {
            if (typeof error == 'function') {
                error(data.backData);
                _toast2.default.info(data.backMsg, 1);
            } else {
                _toast2.default.info(data.backMsg, 1);
            }
        }
    }, error);
}
function getICOPJSON2(url, data, success, error) {
    _ajax2.default.getJSON(url, data, function (data) {
        if (data.code && data.code == 'success') {
            if (typeof success == 'function') {
                success(data.data);
            } else {
                console.log(data.data);
                _toast2.default.success(data.data, 1);
            }
        } else {
            if (typeof error == 'function') {
                error(data.data);
                _toast2.default.info(data.msg, 1);
            } else {
                _toast2.default.info(data.msg, 1);
            }
        }
    }, error);
}
function postMAJSON(url, data, success, error) {
    _ajax2.default.postText(url, data, function (data) {
        var data = JSON.parse(data);
        if (data.flag && data.flag == '0') {
            if (typeof success == 'function') {
                success(data.data);
            } else {
                console.log(data.data);
                _toast2.default.success(res.text, 1);
            }
        } else {
            if (typeof error == 'function') {
                _toast2.default.info(data.desc, 1);
                error(data);
            } else {
                _toast2.default.info(data.desc, 1);
            }
        }
    }, error);
}
function postMAJSON2(url, data, success, error) {
    _ajax2.default.postText(url, data, function (data) {
        var data = JSON.parse(data);
        if (data.code && data.code == 'success') {
            if (typeof success == 'function') {
                success(data.data);
            } else {
                console.log(data.data);
                _toast2.default.success(data.code, 1);
            }
        } else {
            if (typeof error == 'function') {
                _toast2.default.info(data.msg, 1);
                error(data);
            } else {
                _toast2.default.info(data.msg, 1);
            }
        }
    }, error);
}
function postICOPJSON(url, data, success, error) {
    _ajax2.default.postJSON(url, data, function (data) {
        if (data.success && data.success == true) {
            if (typeof success == 'function') {
                success(data.backData);
            } else {
                console.log(data.backData);
                _toast2.default.success(data.backMsg, 1);
            }
        } else {
            if (typeof error == 'function') {
                error(data.backData);
                _toast2.default.info(data.backMsg, 1);
            } else {
                _toast2.default.info(data.backMsg, 1);
            }
        }
    }, error);
}
function postICOPText(url, data, success, error) {
    _ajax2.default.postText(url, data, function (data) {
        var data = JSON.parse(data);
        if (data.success && data.success == true) {
            if (typeof success == 'function') {
                success(data.backData || data.data);
            } else {
                console.log(data.backData || data.data);
                _toast2.default.success(data.backMsg || data.msg, 1);
            }
        } else {
            if (typeof error == 'function') {
                error(data.backData || data.data);
                _toast2.default.info(data.backMsg || data.msg, 1);
            } else {
                _toast2.default.info(data.backMsg || data.msg, 1);
            }
        }
    }, error);
}
function postICOPForm(url, data, success, error) {
    _ajax2.default.postForm(url, data, function (data) {
        if (data.success && data.success == true) {
            if (typeof success == 'function') {
                success(data.backData);
            } else {
                console.log(data.backData);
                _toast2.default.success(data.backMsg, 1);
            }
        } else {
            if (typeof error == 'function') {
                error(data.backData);
                _toast2.default.info(data.backMsg, 1);
            } else {
                _toast2.default.info(data.backMsg, 1);
            }
        }
    }, error);
}

function callback(err, res, success, error) {
    if (err || res && res.badRequest) {
        if (typeof error == 'function') {
            error(res);
        } else {
            _toast2.default.info(err.message, 1);
        }
    }

    if (res && res.ok) {
        var data = JSON.parse(res.text);
        if (data.code && data.code == 'success') {
            if (typeof success == 'function') {
                success(data.data);
            } else {
                console.log(data.data);
                _toast2.default.success(res.text, 1);
            }
        } else {
            if (typeof error == 'function') {
                error(data);
                _toast2.default.info(data.msg, 1);
            } else {
                _toast2.default.info(data.msg, 1);
            }
        }
    }
}

function postNoAuth(url, data, success, error) {
    _superagent2.default.post(url).send(data).end(function (err, res) {
        callbackMa(err, res, success, error);
    });
}

function callbackMa(err, res, success, error) {
    if (err || res && res.badRequest) {
        if (typeof error == 'function') {
            error(res);
        } else {
            _toast2.default.info(err.message, 1);
        }
    }

    if (res && res.ok) {
        var data = JSON.parse(res.text);
        if (data.flag && data.flag == '0') {
            if (typeof success == 'function') {
                success(data.data);
            } else {
                console.log(data.data);
                _toast2.default.success(res.text, 1);
            }
        } else {
            if (typeof error == 'function') {
                error(data);
                _toast2.default.info(data.desc, 1);
            } else {
                _toast2.default.info(data.desc, 1);
            }
        }
    }
}