'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var React = require('react');
var uuid = require('uuid');
var YYComponent = require('./YYComponent');
var YYPropTypes = require('./YYPropTypes');

var _uuid = 0;
var YYClass = {
    PropTypes: YYPropTypes,
    inherits: function inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + (typeof superClass === 'undefined' ? 'undefined' : _typeof(superClass)));
        }
        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: { value: subClass, enumerable: false, writable: true, configurable: true }
        });

        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    },
    uuid: function uuid() {
        return Date.now() + '_' + _uuid++;
    },
    uuid32: function uuid32() {
        var uuidArr = uuid.v4().split("-");
        return uuidArr.join("");
    },
    create: function create(spec) {
        var _exClass = Object.assign({}, YYComponent, spec);
        var _class = React.createClass(_exClass);
        return _class;
    },
    field: function field(propName, propValue, propType, isRequired, propDesc) {
        return {
            name: propName, value: propValue, type: propType, isRequired: isRequired, desc: propDesc };
    }
};

module.exports = YYClass;