'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _picker = require('antd-mobile/lib/picker');

var _picker2 = _interopRequireDefault(_picker);

var _list = require('antd-mobile/lib/list');

var _list2 = _interopRequireDefault(_list);

var _toast = require('antd-mobile/lib/toast');

var _toast2 = _interopRequireDefault(_toast);

var _steps = require('antd-mobile/lib/steps');

var _steps2 = _interopRequireDefault(_steps);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd-mobile/lib/picker/style/css');

require('antd-mobile/lib/list/style/css');

require('antd-mobile/lib/toast/style/css');

require('antd-mobile/lib/steps/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcForm = require('rc-form');

require('./YYApprove.less');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _RestUrl = require('../../common/RestUrl');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Step = _steps2.default.Step;

var YYApproveHistory = function (_React$Component) {
    _inherits(YYApproveHistory, _React$Component);

    function YYApproveHistory(props) {
        _classCallCheck(this, YYApproveHistory);

        var _this = _possibleConstructorReturn(this, (YYApproveHistory.__proto__ || Object.getPrototypeOf(YYApproveHistory)).call(this, props));

        _this.postHistoryInfo = function () {
            var ajax = window.YYUtils.Ajax;
            var _this$props = _this.props,
                userId = _this$props.userId,
                billId = _this$props.billId;
            var bpmId = _this.state.bpmId;

            ajax.postText(_RestUrl.MODULE_URL.querySingleHistoricProcessInfo, {
                'billId': billId,
                'userId': userId,
                bpmId: bpmId,
                isFinish: false
            }, function (testData) {
                var data = JSON.parse(testData);
                if (data.success && data.success == true) {
                    var array = data.data.array.reverse();
                    _this.setState({
                        loading: false,
                        bpmProcessInfo: data.data.array
                    });
                } else {
                    _toast2.default.info('查看审批记录失败，请检查参数', 1);
                }
            });
        };

        _this.switchStatus = function (state) {
            var item = '';
            switch (state) {
                case "completed":
                    return '';
                case "delete":
                    return 'error';
                    break;
                case "ACTIVITI_DELETED":
                    return 'error';
                    break;
                case "disagree_continue":
                    return 'wait';
                    break;
                case "deleted":
                    return 'wait';
                    break;
                case "reject":
                    return 'error';
                    break;
                case "withdraw":
                    return 'wait';
                    break;
                case "stop":
                    return 'error';
                    break;
                case "callback":
                    return 'error';
                    break;
                default:
                    return '';
                    break;
            }
        };

        _this.bpmsList = [];
        _this.state = {
            loading: true,
            bpmProcessInfo: [],
            bpmId: ''
        };
        return _this;
    }

    _createClass(YYApproveHistory, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this2 = this;

            var ajax = window.YYUtils.Ajax;
            var _props = this.props,
                userId = _props.userId,
                billId = _props.billId;

            ajax.getText(_RestUrl.MODULE_URL.getBpmIds, { 'billId': billId }, function (testData) {
                var data = JSON.parse(testData);
                if (data.success && data.success == true) {
                    if (data.bpmIdList && data.bpmIdList.length > 0) {
                        _this2.setState({
                            bpmId: data.bpmIdList[0]
                        });
                        for (var i = data.bpmIdList.length; i >= 1; i--) {
                            _this2.bpmsList.push({
                                value: data.bpmIdList.length - i,
                                label: '第' + i + '次',
                                bpmId: data.bpmIdList[data.bpmIdList.length - i]
                            });
                        }
                    } else {
                        _toast2.default.info('没有审批历史', 2);
                    }
                } else {
                    _toast2.default.info('查看审批记录失败，请检查参数', 2);
                }
            });
            this.postHistoryInfo();
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var getFieldProps = this.props.form.getFieldProps;
            var _state = this.state,
                bpmProcessInfo = _state.bpmProcessInfo,
                loading = _state.loading,
                bpmId = _state.bpmId;

            var _props2 = this.props,
                userId = _props2.userId,
                billId = _props2.billId,
                className = _props2.className,
                restProps = _objectWithoutProperties(_props2, ['userId', 'billId', 'className']);

            var basicCls = (0, _classnames2.default)('yy-bpm-steps', className);
            return _react2.default.createElement(
                'div',
                { className: 'yy-approve-history' },
                _react2.default.createElement(
                    _list2.default,
                    null,
                    _react2.default.createElement(
                        _picker2.default,
                        _extends({ data: this.bpmsList,
                            cols: 1
                        }, getFieldProps('district', { initialValue: [0] }), {
                            onOk: function onOk(v) {
                                _this3.setState({ bpmId: _this3.bpmsList[v].bpmId });
                                _this3.postHistoryInfo();
                            } }),
                        _react2.default.createElement(
                            _list2.default.Item,
                            { arrow: 'horizontal' },
                            '\u5BA1\u6279\u8BB0\u5F55\u6B21\u6570'
                        )
                    )
                ),
                _react2.default.createElement(
                    'div',
                    { className: 'yy-bpm-iframe' },
                    _react2.default.createElement('iframe', {
                        id: 'demoFrame',
                        title: 'yylib-antd-mobile',
                        name: 'demoFrame',
                        style: { width: 'calc(100vw - 2rem)', border: 'none' },
                        src: _RestUrl.MODULE_URL.diagramUrl + bpmId })
                ),
                _react2.default.createElement(
                    _steps2.default,
                    _extends({}, restProps, { className: basicCls, size: 'small', current: bpmProcessInfo.length }),
                    bpmProcessInfo && bpmProcessInfo.length > 0 ? bpmProcessInfo.map(function (item, index) {
                        return _react2.default.createElement(Step, {
                            key: index,
                            description: _react2.default.createElement(
                                'div',
                                { className: 'approveItem' },
                                _react2.default.createElement(
                                    'div',
                                    null,
                                    _react2.default.createElement(
                                        'span',
                                        { className: 'left-top' },
                                        item.approveUserName
                                    ),
                                    _react2.default.createElement(
                                        'span',
                                        {
                                            className: 'right-top' },
                                        item.approveDatetime
                                    )
                                ),
                                _react2.default.createElement(
                                    'div',
                                    null,
                                    _react2.default.createElement(
                                        'span',
                                        { className: 'left-bottom' },
                                        item.approveState
                                    ),
                                    _react2.default.createElement(
                                        'span',
                                        {
                                            className: 'right-bottom' },
                                        item.approveComment
                                    )
                                )
                            ),
                            status: _this3.switchStatus(item.state) });
                    }) : null
                )
            );
        }
    }]);

    return YYApproveHistory;
}(_react2.default.Component);

YYApproveHistory.defaultProps = {
    userId: '',
    billId: '' };
var YYApproveHistoryFrom = (0, _rcForm.createForm)()(YYApproveHistory);
exports.default = YYApproveHistoryFrom;