'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _list = require('antd-mobile/lib/list');

var _list2 = _interopRequireDefault(_list);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd-mobile/lib/list/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _YYIcon = require('../icon/YYIcon');

var _YYIcon2 = _interopRequireDefault(_YYIcon);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _FunctionUtil = require('../../utils/FunctionUtil');

require('./YYItemText.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Item = _list2.default.Item;
var Brief = Item.Brief;

var YYItemSelect = function (_Component) {
  _inherits(YYItemSelect, _Component);

  function YYItemSelect(props) {
    _classCallCheck(this, YYItemSelect);

    var _this = _possibleConstructorReturn(this, (YYItemSelect.__proto__ || Object.getPrototypeOf(YYItemSelect)).call(this, props));

    _this.componentWillReceiveProps = function (nextProps) {
      var getFieldValue = nextProps.form.getFieldValue;

      var valueField = getFieldValue(nextProps.field);
      if (nextProps.data != _this.props.data) {
        _this.setState({
          data: nextProps.data
        });
      }
      if (nextProps.value) {
        _this.setState({
          value: nextProps.value
        });
      }
      if (valueField) {
        _this.setState({
          value: valueField
        });
      }
    };

    _this.validateCallBack = function (rule, value, callback) {
      if ((0, _FunctionUtil.isFunction)(_this.props.validateCallBack)) {
        _this.props.validateCallBack(rule, value, callback);
        callback();
      } else {
        callback();
      }
    };

    _this.state = {
      data: [],
      value: null
    };
    return _this;
  }

  _createClass(YYItemSelect, [{
    key: 'createDesignData',
    value: function createDesignData() {
      var selectColor = this.props.selectColor;

      var data = [{ label: '一般', value: '1' }, { label: '严重', value: '2' }, { label: '紧急', value: '3' }];

      this.setData(data);
    }
  }, {
    key: 'setData',
    value: function setData(data) {
      this.setState({
        data: data
      });
    }
  }, {
    key: 'onClick',
    value: function onClick(data) {
      var _this2 = this;

      if (this.props.disabled) {
        return;
      }
      var value = data.value;
      this.setState({ value: value }, function () {
        var fields = {};
        fields[_this2.props.field] = {
          name: _this2.props.field,
          value: value
        };
        _this2.props.form.setFields(fields);
        if ((0, _FunctionUtil.isFunction)(_this2.props.onChange)) {
          _this2.props.onChange(value);
        }
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          RunInDesign = _props.RunInDesign,
          data = _props.data,
          value = _props.value,
          field = _props.field;
      var getFieldValue = this.props.form.getFieldValue;

      var valueField = getFieldValue(field);
      if (RunInDesign) {
        this.createDesignData();
      } else {
        if (data) {
          this.setState({
            data: data
          });
        }
        if (value) {
          this.setState({
            value: value
          });
        }
        if (valueField) {
          this.setState({
            value: valueField
          });
        }
      }
    }
  }, {
    key: 'renderItems',
    value: function renderItems(data) {
      var _this3 = this;

      var list = [];
      var _props2 = this.props,
          unselectColor = _props2.unselectColor,
          selectColor = _props2.selectColor;

      data.map(function (item, index) {
        if (item.value === _this3.state.value) {
          list.push(_react2.default.createElement(
            'div',
            { key: index, className: 'item select-item', style: { background: selectColor ? selectColor : '#ffcf24', border: '1px solid ' + (selectColor ? selectColor : '#ffcf24') }, onClick: _this3.onClick.bind(_this3, item) },
            item.label
          ));
        } else {
          list.push(_react2.default.createElement(
            'div',
            { key: index, className: 'item', style: { background: '#fff', border: '1px solid #ADB2BB' }, onClick: _this3.onClick.bind(_this3, item) },
            item.label
          ));
        }
      });
      return list;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props$form = this.props.form,
          getFieldProps = _props$form.getFieldProps,
          getFieldValue = _props$form.getFieldValue;

      var _props3 = this.props,
          field = _props3.field,
          label = _props3.label,
          bottomLine = _props3.bottomLine,
          visible = _props3.visible,
          selectColor = _props3.selectColor,
          value = _props3.value,
          disabled = _props3.disabled,
          required = _props3.required,
          trigger = _props3.trigger,
          findUI = _props3.findUI,
          offline = _props3.offline,
          parentType = _props3.parentType,
          uiorigin = _props3.uiorigin,
          RunInDesign = _props3.RunInDesign,
          uititle = _props3.uititle,
          uitype = _props3.uitype,
          uikey = _props3.uikey,
          nid = _props3.nid,
          control_event = _props3.control_event,
          restProps = _objectWithoutProperties(_props3, ['field', 'label', 'bottomLine', 'visible', 'selectColor', 'value', 'disabled', 'required', 'trigger', 'findUI', 'offline', 'parentType', 'uiorigin', 'RunInDesign', 'uititle', 'uitype', 'uikey', 'nid', 'control_event']);

      var wrapClz = (0, _classnames2.default)('yy-itemselect', !visible && 'hidden', !bottomLine && 'no-bottom-line', this.props.className);
      var labelWrapClz = (0, _classnames2.default)('yy-itemselect-label', !visible && 'hidden', this.props.className);
      var data = this.state.data;

      var select = [];
      var requiredMsg = '必填项' + label + '未填写';
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { className: labelWrapClz },
          required ? _react2.default.createElement(
            'span',
            { className: 'yy-label-required' },
            label
          ) : label
        ),
        _react2.default.createElement(
          Item,
          _extends({}, restProps, {
            className: wrapClz
          }, (0, _FunctionUtil.isFunction)(getFieldProps) ? getFieldProps(field, {
            initialValue: value,
            rules: [{ required: required, message: requiredMsg }, { validator: this.validateCallBack }],
            trigger: trigger,
            valuePropName: 'value'
          }) : null),
          _react2.default.createElement(
            'div',
            { className: 'selects' },
            this.renderItems(data)
          )
        )
      );
    }
  }]);

  return YYItemSelect;
}(_react.Component);

YYItemSelect.defaultProps = {
  field: "default",
  label: '',
  visible: true,
  value: null,
  trigger: "onChange",

  findUI: '',
  offline: false,
  parentType: '',
  uiorigin: '',
  RunInDesign: false,
  uititle: '',
  uitype: '',
  uikey: '',
  nid: '',
  control_event: {}
};
exports.default = YYItemSelect;