'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _list = require('antd-mobile/lib/list');

var _list2 = _interopRequireDefault(_list);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd-mobile/lib/list/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _YYIcon = require('../icon/YYIcon');

var _YYIcon2 = _interopRequireDefault(_YYIcon);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _FunctionUtil = require('../../utils/FunctionUtil');

require('./YYItemText.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Item = _list2.default.Item;
var Brief = Item.Brief;

var YYItemText = function (_Component) {
  _inherits(YYItemText, _Component);

  function YYItemText() {
    _classCallCheck(this, YYItemText);

    return _possibleConstructorReturn(this, (YYItemText.__proto__ || Object.getPrototypeOf(YYItemText)).apply(this, arguments));
  }

  _createClass(YYItemText, [{
    key: 'getExtra',
    value: function getExtra(value) {
      var extra = {};
      if (this.props.inline) {
        extra = { extra: value };
      }
      return extra;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props$form = this.props.form,
          getFieldProps = _props$form.getFieldProps,
          getFieldValue = _props$form.getFieldValue;

      var _props = this.props,
          field = _props.field,
          label = _props.label,
          bottomLine = _props.bottomLine,
          inline = _props.inline,
          wrap = _props.wrap,
          visible = _props.visible,
          size = _props.size,
          labelNumber = _props.labelNumber,
          contentType = _props.contentType,
          findUI = _props.findUI,
          offline = _props.offline,
          parentType = _props.parentType,
          uiorigin = _props.uiorigin,
          RunInDesign = _props.RunInDesign,
          uititle = _props.uititle,
          uitype = _props.uitype,
          uikey = _props.uikey,
          nid = _props.nid,
          restProps = _objectWithoutProperties(_props, ['field', 'label', 'bottomLine', 'inline', 'wrap', 'visible', 'size', 'labelNumber', 'contentType', 'findUI', 'offline', 'parentType', 'uiorigin', 'RunInDesign', 'uititle', 'uitype', 'uikey', 'nid']);

      var wrapClz = (0, _classnames2.default)('yy-itemtext', !visible && 'hidden', !inline && 'no-inline', size, !bottomLine && 'no-bottom-line', this.props.className);
      var value = getFieldValue(field);
      if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) == "object") {
        value = value && value.name ? value.name : "";
      }
      return _react2.default.createElement(
        Item,
        _extends({}, restProps, {
          className: wrapClz,
          wrap: wrap
        }, (0, _FunctionUtil.isFunction)(getFieldProps) ? getFieldProps(field, {}) : null),
        _react2.default.createElement(
          'div',
          { className: 'am-list-line am-list-line-content' },
          _react2.default.createElement(
            'div',
            { className: 'am-input-label am-input-label-' + labelNumber },
            label
          ),
          inline && _react2.default.createElement(
            'div',
            { className: 'am-input-control am-input-control-' + contentType },
            value
          )
        ),
        !inline && _react2.default.createElement(
          Brief,
          null,
          value
        )
      );
    }
  }]);

  return YYItemText;
}(_react.Component);

YYItemText.defaultProps = {
  field: "default",
  label: '显示名称:',
  bottomLine: true,
  inline: true,
  visible: true,
  labelNumber: 7,
  wrap: false,
  size: 'big',
  contentType: 'left',

  findUI: '',
  offline: false,
  parentType: '',
  uiorigin: '',
  RunInDesign: false,
  uititle: '',
  uitype: '',
  uikey: '',
  nid: ''
};
exports.default = YYItemText;