'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _list = require('antd-mobile/lib/list');

var _list2 = _interopRequireDefault(_list);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd-mobile/lib/list/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./YYListItem.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var YYListItem = function (_Component) {
  _inherits(YYListItem, _Component);

  function YYListItem() {
    _classCallCheck(this, YYListItem);

    return _possibleConstructorReturn(this, (YYListItem.__proto__ || Object.getPrototypeOf(YYListItem)).apply(this, arguments));
  }

  _createClass(YYListItem, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          size = _props.size,
          arrow = _props.arrow,
          disabled = _props.disabled,
          RunInDesign = _props.RunInDesign,
          className = _props.className,
          wrap = _props.wrap,
          showBorder = _props.showBorder,
          multipleLine = _props.multipleLine,
          title = _props.title,
          titleExtra = _props.titleExtra,
          leftFontMode = _props.leftFontMode,
          rightFontMode = _props.rightFontMode,
          visible = _props.visible,
          style = _props.style,
          rightFontType = _props.rightFontType,
          children = _props.children;

      var leftclass = leftFontMode ? "yy-listitem-leftmode" : "";
      var rightclass = rightFontMode ? "yy-listitem-rightmode" : "";
      var borderClass = !showBorder ? "yy-listitem-noborder" : "";
      var rightFontClass = 'yy-listitem-' + rightFontType;
      var sizeClass = "yy-listitem-" + size;
      var wrapClz = (0, _classnames2.default)('yy-listitem ' + rightclass + " " + leftclass + " " + borderClass + " " + sizeClass + ' ' + rightFontClass, !visible && 'hidden', className);
      return _react2.default.createElement(
        _list2.default.Item,
        {
          multipleLine: multipleLine,
          extra: titleExtra && titleExtra != "" ? titleExtra : undefined,
          wrap: wrap,
          disabled: disabled,
          className: wrapClz,
          arrow: arrow,
          style: style,
          onClick: this.onClick.bind(this)
        },
        title,
        children && children.length && _react2.default.createElement(
          'div',
          { className: 'yy-extra' },
          children
        )
      );
    }
  }, {
    key: 'onClick',
    value: function onClick() {
      if (this.props.onClick) {
        this.props.onClick();
      }
    }
  }]);

  return YYListItem;
}(_react.Component);

YYListItem.defaultProps = {
  visible: true,
  rightFontType: 'right'
};
exports.default = YYListItem;