'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _modal = require('antd-mobile/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd-mobile/lib/modal/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('./YYModal.less');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function closest(el, selector) {
  var matchesSelector = el.matches || el.webkitMatchesSelector || el.mozMatchesSelector || el.msMatchesSelector;
  while (el) {
    if (matchesSelector.call(el, selector)) {
      return el;
    }
    el = el.parentElement;
  }
  return null;
}

var YYModal = function (_React$Component) {
  _inherits(YYModal, _React$Component);

  function YYModal(props) {
    _classCallCheck(this, YYModal);

    var _this = _possibleConstructorReturn(this, (YYModal.__proto__ || Object.getPrototypeOf(YYModal)).call(this, props));

    _this.onWrapTouchStart = function (e) {
      if (!/iPhone|iPod|iPad/i.test(navigator.userAgent)) {
        return;
      }
      var pNode = closest(e.target, '.am-modal-content');
      if (!pNode) {
        e.preventDefault();
      }
    };

    _this.state = {};
    return _this;
  }

  _createClass(YYModal, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (!prevProps.visible) {
        if (this.props.onOpen) {
          this.props.onOpen();
        }
      }
    }
  }, {
    key: 'onClose',
    value: function onClose() {
      this.props.onClose && this.props.onClose();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          fill = _props.fill,
          RunInDesign = _props.RunInDesign,
          modalContent = _props.modalContent,
          popup = _props.popup,
          children = _props.children,
          visible = _props.visible,
          animationType = _props.animationType,
          maskClosable = _props.maskClosable,
          title = _props.title,
          style = _props.style,
          restProps = _objectWithoutProperties(_props, ['fill', 'RunInDesign', 'modalContent', 'popup', 'children', 'visible', 'animationType', 'maskClosable', 'title', 'style']);

      var child = children ? children : modalContent;
      var wrapClz = (0, _classnames2.default)('yy-modal', this.props.className);
      wrapClz = fill ? (0, _classnames2.default)(" yy-modal yy-modal-fill ") : wrapClz;
      if (RunInDesign) {
        if (window.ModelID && this.props.nid == window.ModelID) {
          visible = true;
        }
      }
      return _react2.default.createElement(
        'div',
        null,
        popup ? _react2.default.createElement(
          _modal2.default,
          _extends({}, restProps, {
            style: { backgroundColor: "black" },
            className: wrapClz,
            visible: visible,
            popup: true,
            animationType: animationType,
            title: title,
            maskClosable: true,
            onClose: this.onClose.bind(this)
          }),
          child
        ) : _react2.default.createElement(
          _modal2.default,
          _extends({}, restProps, {
            className: wrapClz,
            wrapProps: { onTouchStart: this.onWrapTouchStart }
          }),
          modalContent
        )
      );
    }
  }]);

  return YYModal;
}(_react2.default.Component);

YYModal.defaultProps = {
  popup: true
};

YYModal.alert = _modal2.default.alert;
YYModal.confirm = _modal2.default.confirm;
YYModal.prompt = _modal2.default.prompt;
YYModal.operation = _modal2.default.operation;
exports.default = YYModal;