'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _navBar = require('antd-mobile/lib/nav-bar');

var _navBar2 = _interopRequireDefault(_navBar);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd-mobile/lib/nav-bar/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _YYIcon = require('./../icon/YYIcon');

var _YYIcon2 = _interopRequireDefault(_YYIcon);

var _FunctionUtil = require('../../utils/FunctionUtil');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lfwUtil = require('../../utils/lfwUtil');

require('./YYNavBar.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var YYNavBar = function (_Component) {
    _inherits(YYNavBar, _Component);

    function YYNavBar() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, YYNavBar);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = YYNavBar.__proto__ || Object.getPrototypeOf(YYNavBar)).call.apply(_ref, [this].concat(args))), _this), _this.onLeftClick = function (e) {
            if (_this.props.RunInDesign) {
                return;
            }
            if ((0, _FunctionUtil.isFunction)(_this.props.onLeftClick)) {
                _this.props.onLeftClick(e);
            } else {
                (0, _lfwUtil.backOrClose)();
            }
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(YYNavBar, [{
        key: 'onRightClick',
        value: function onRightClick(e) {
            if ((0, _FunctionUtil.isFunction)(this.props.onRightClick)) {
                this.props.onRightClick(e);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                mode = _props.mode,
                leftIcon = _props.leftIcon,
                leftContent = _props.leftContent,
                rightIcon = _props.rightIcon,
                rightContent = _props.rightContent,
                children = _props.children,
                className = _props.className,
                visible = _props.visible,
                disabled = _props.disabled,
                uititle = _props.uititle,
                control_event = _props.control_event,
                onRightClick = _props.onRightClick,
                offline = _props.offline,
                parentType = _props.parentType,
                uiorigin = _props.uiorigin,
                RunInDesign = _props.RunInDesign,
                uitype = _props.uitype,
                uikey = _props.uikey,
                nid = _props.nid,
                findUI = _props.findUI,
                restProps = _objectWithoutProperties(_props, ['mode', 'leftIcon', 'leftContent', 'rightIcon', 'rightContent', 'children', 'className', 'visible', 'disabled', 'uititle', 'control_event', 'onRightClick', 'offline', 'parentType', 'uiorigin', 'RunInDesign', 'uitype', 'uikey', 'nid', 'findUI']);

            var wrapClz = (0, _classnames2.default)('yy-navBar', !visible && 'hidden', className);

            var leftIconCom = typeof leftIcon === 'string' ? _react2.default.createElement(_YYIcon2.default, { type: leftIcon }) : leftIcon;
            var rightCom = rightIcon ? _react2.default.createElement(
                'span',
                { className: 'rightContent', onClick: this.onRightClick.bind(this) },
                rightContent,
                _react2.default.createElement(_YYIcon2.default, { className: 'rightIcon', type: rightIcon })
            ) : _react2.default.createElement(
                'span',
                { className: 'rightContent', onClick: this.onRightClick.bind(this) },
                rightContent
            );
            return _react2.default.createElement(
                _navBar2.default,
                _extends({}, restProps, {
                    className: wrapClz,
                    mode: mode,
                    icon: !disabled ? leftIconCom : null,
                    leftContent: !disabled ? leftContent : null,
                    onLeftClick: !disabled ? this.onLeftClick : null,
                    rightContent: !disabled ? rightCom : null }),
                children
            );
        }
    }]);

    return YYNavBar;
}(_react.Component);

YYNavBar.defaultProps = {
    mode: 'light',
    leftIcon: null,
    leftContent: null,
    rightIcon: null,
    rightContent: null,
    onLeftClick: null,
    visible: true,
    disabled: false,

    uititle: '',
    control_event: {},
    onRightClick: '',
    offline: false,
    parentType: '',
    uiorigin: '',
    RunInDesign: false,
    uitype: '',
    uikey: '',
    nid: '',
    findUI: ''

};
exports.default = YYNavBar;