'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _pullToRefresh = require('antd-mobile/lib/pull-to-refresh');

var _pullToRefresh2 = _interopRequireDefault(_pullToRefresh);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd-mobile/lib/pull-to-refresh/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

require('./YYPullToRefresh.less');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var YYPullToRefresh = function (_Component) {
  _inherits(YYPullToRefresh, _Component);

  function YYPullToRefresh(props) {
    _classCallCheck(this, YYPullToRefresh);

    var _this = _possibleConstructorReturn(this, (YYPullToRefresh.__proto__ || Object.getPrototypeOf(YYPullToRefresh)).call(this, props));

    _this.state = {
      data: [],
      refreshing: false,
      height: 0
    };
    return _this;
  }

  _createClass(YYPullToRefresh, [{
    key: 'createDesignData',
    value: function createDesignData() {
      var dataArr = [];
      for (var i = 0; i < 20; i++) {
        dataArr.push(i);
      }
      this.setState({
        data: dataArr
      });
    }
  }, {
    key: 'onRefresh',
    value: function onRefresh() {
      var _this2 = this;

      if (this.props.onRefresh) {
        this.props.onRefresh();
      } else {
        this.setState({ refreshing: true });
        setTimeout(function () {
          _this2.setState({ refreshing: false });
        }, 1000);
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var RunInDesign = this.props.RunInDesign;

      var hei = _reactDom2.default.findDOMNode(this.ptr).offsetTop;
      this.setState({
        height: hei
      });
      if (RunInDesign) {
        this.createDesignData();
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextprops) {
      if (nextprops.refreshing !== this.state.refreshing) {
        this.setState({
          refreshing: nextprops.refreshing
        });
      }
      if (nextprops.RunInDesign) {
        this.createDesignData();
      }
    }
  }, {
    key: 'setRefreshing',
    value: function setRefreshing(flag) {
      this.setState({
        refreshing: flag
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          distanceToRefresh = _props.distanceToRefresh,
          direction = _props.direction,
          refreshing = _props.refreshing,
          children = _props.children,
          findUI = _props.findUI,
          offline = _props.offline,
          parentType = _props.parentType,
          uiorigin = _props.uiorigin,
          RunInDesign = _props.RunInDesign,
          uititle = _props.uititle,
          uitype = _props.uitype,
          uikey = _props.uikey,
          nid = _props.nid,
          control_event = _props.control_event,
          damping = _props.damping,
          restProps = _objectWithoutProperties(_props, ['distanceToRefresh', 'direction', 'refreshing', 'children', 'findUI', 'offline', 'parentType', 'uiorigin', 'RunInDesign', 'uititle', 'uitype', 'uikey', 'nid', 'control_event', 'damping']);

      var wrapClz = (0, _classnames2.default)('yy-pull-to-refresh', this.props.className);
      var height = this.state.height;

      var heightstr = 'calc(100% - ' + height + 'px)';
      return _react2.default.createElement(
        _pullToRefresh2.default,
        _extends({}, restProps, {
          damping: damping,
          className: wrapClz,
          ref: function ref(el) {
            return _this3.ptr = el;
          },
          style: {
            height: heightstr,
            overflow: 'auto'
          },
          indicator: direction == 'down' ? {} : { deactivate: '上拉可以刷新' },
          direction: direction,
          distanceToRefresh: distanceToRefresh,
          refreshing: this.state.refreshing,
          onRefresh: this.onRefresh.bind(this) }),
        this.props.RunInDesign && !children ? this.state.data.map(function (i) {
          return _react2.default.createElement(
            'div',
            { key: i, style: { textAlign: 'center', padding: 20 } },
            direction == 'down' ? 'pull down' : 'pull up',
            ' ',
            i
          );
        }) : children
      );
    }
  }]);

  return YYPullToRefresh;
}(_react.Component);

YYPullToRefresh.defaultProps = {
  damping: 100,

  findUI: '',
  offline: false,
  parentType: '',
  uiorigin: '',
  RunInDesign: false,
  uititle: '',
  uitype: '',
  uikey: '',
  nid: '',
  control_event: {}
};
exports.default = YYPullToRefresh;