'use strict';

var UrlUtils = require('../../utils/UrlUtils');

var _require = require('./api.all'),
    FormApi = _require.FormApi,
    EditTableApi = _require.EditTableApi;

var DefaultActions = {
    gotoPage: function gotoPage(options) {
        var event = options.event,
            action = options.action,
            ui = options.ui;
        var appCode = action.appCode,
            pageCode = action.pageCode;

        var viewUrl = UrlUtils.fillUrlParams('#/pages/view/{appCode}/{pageCode}', {
            appCode: appCode,
            pageCode: pageCode
        });
        window.open(viewUrl, '_self');
    },

    formSave: function formSave(options) {
        var event = options.event,
            action = options.action,
            ui = options.ui;
        var storeKey = action.storeKey;

        if (storeKey) {
            FormApi.saveData(this, { storeKey: storeKey });
        }
    },

    formDelete: function formDelete(options) {
        var event = options.event,
            action = options.action,
            ui = options.ui;
        var storeKey = action.storeKey;

        if (storeKey) {
            FormApi.deleteData(this, { storeKey: storeKey });
        }
    },

    editTableAddRow: function editTableAddRow(options) {
        var event = options.event,
            action = options.action,
            ui = options.ui;
        var editTableKey = action.editTableKey;

        if (editTableKey) {
            EditTableApi.addRow(this, editTableKey);
        }
    },

    editTableDelRow: function editTableDelRow(options) {
        var event = options.event,
            action = options.action,
            ui = options.ui;
        var editTableKey = action.editTableKey;

        if (editTableKey) {
            EditTableApi.delRow(this, editTableKey);
        }
    }
};

module.exports = DefaultActions;