'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _list = require('antd-mobile/lib/list');

var _list2 = _interopRequireDefault(_list);

var _radio = require('antd-mobile/lib/radio');

var _radio2 = _interopRequireDefault(_radio);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd-mobile/lib/list/style/css');

require('antd-mobile/lib/radio/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _FunctionUtil = require('../../utils/FunctionUtil');

require('./YYRadioGroup.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RadioItem = _radio2.default.RadioItem;

var YYRadioGroup = function (_React$Component) {
    _inherits(YYRadioGroup, _React$Component);

    function YYRadioGroup() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, YYRadioGroup);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = YYRadioGroup.__proto__ || Object.getPrototypeOf(YYRadioGroup)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            value: _this.props.value !== undefined ? _this.props.value : _this.props.defaultValue
        }, _this.componentWillReceiveProps = function (nextProps) {
            if ('defaultValue' in nextProps) {
                if (_this.props.defaultValue != nextProps.defaultValue) {
                    _this.setState({ value: nextProps.defaultValue });
                }
            }

            if ('value' in nextProps) {
                if (_this.props.value != nextProps.value) {
                    _this.setState({ value: nextProps.value });
                }
            }
        }, _this._onChange = function (_ref2, event) {
            var value = _ref2.value,
                i = _ref2.i;

            var valueObject = i;
            var _this$props = _this.props,
                disabled = _this$props.disabled,
                field = _this$props.field;
            var getFieldProps = _this.props.form.getFieldProps;

            if (event && event.target) {
                event.target.value = event.target.checked;
                if (disabled) {
                    valueObject = getFieldProps(field).value;
                }
            }
            _this.setState({ value: valueObject.value }, function () {
                var fields = {};
                fields[_this.props.field] = {
                    name: _this.props.field,
                    value: valueObject
                };
                _this.props.form.setFields(fields);
                if ((0, _FunctionUtil.isFunction)(_this.props.onChange)) {
                    _this.props.onChange(value, i);
                }
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(YYRadioGroup, [{
        key: 'render',
        value: function render() {
            var _this2 = this;

            var getFieldProps = this.props.form.getFieldProps;

            var _props = this.props,
                RunInDesign = _props.RunInDesign,
                field = _props.field,
                label = _props.label,
                options = _props.options,
                required = _props.required,
                visible = _props.visible,
                disabled = _props.disabled,
                restProps = _objectWithoutProperties(_props, ['RunInDesign', 'field', 'label', 'options', 'required', 'visible', 'disabled']);

            var wrapClz = (0, _classnames2.default)('yy-radio-group', !visible && 'hidden', required && 'label-required', this.props.className);
            var value = this.state.value;

            var valueObject = getFieldProps(field).value && getFieldProps(field).value.value;
            var optionsDesign = [{ label: 'a', value: 'a', checked: true }, { label: 'b', value: 'b', checked: false }, { label: 'c', value: 'c', checked: false }];
            var requiredMsg = '必选项' + label + '必选';
            return _react2.default.createElement(
                _list2.default,
                _extends({}, restProps, {
                    className: wrapClz
                }, (0, _FunctionUtil.isFunction)(getFieldProps) ? getFieldProps(field, {
                    initialValue: value,
                    valuePropName: 'value',
                    rules: [{ required: required, message: requiredMsg }]
                }) : null, {
                    renderHeader: label
                }),
                options && options.length > 0 ? options.map(function (i) {
                    return _react2.default.createElement(
                        'div',
                        { className: 'radio-item', key: i.value },
                        _react2.default.createElement(
                            _radio2.default,
                            { key: i.value, checked: valueObject == i.value || value == i.value || i.checked, onChange: _this2._onChange.bind(_this2, { value: i.value, i: i }) },
                            i.label
                        )
                    );
                }) : null,
                RunInDesign ? optionsDesign.map(function (i) {
                    return _react2.default.createElement(
                        'div',
                        { className: 'radio-item', key: i.value },
                        _react2.default.createElement(
                            _radio2.default,
                            { key: i.value, checked: value == i.value || i.checked, onChange: _this2._onChange.bind(_this2, i.value) },
                            i.label
                        )
                    );
                }) : null
            );
        }
    }]);

    return YYRadioGroup;
}(_react2.default.Component);

YYRadioGroup.defaultProps = {
    field: 'default',
    label: '',
    options: null,
    defaultValue: [],
    visible: true
};

exports.default = YYRadioGroup;