'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _list = require('antd-mobile/lib/list');

var _list2 = _interopRequireDefault(_list);

var _stepper = require('antd-mobile/lib/stepper');

var _stepper2 = _interopRequireDefault(_stepper);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd-mobile/lib/list/style/css');

require('antd-mobile/lib/stepper/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FunctionUtil = require('../../utils/FunctionUtil');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _YYIcon = require('../icon/YYIcon');

var _YYIcon2 = _interopRequireDefault(_YYIcon);

require('./YYStepper.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var YYStepper = function (_React$Component) {
    _inherits(YYStepper, _React$Component);

    function YYStepper() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, YYStepper);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = YYStepper.__proto__ || Object.getPrototypeOf(YYStepper)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            value: _this.props.value != undefined ? _this.props.value : _this.props.defaultValue
        }, _this.componentWillReceiveProps = function (nextProps) {
            var _nextProps$form = nextProps.form,
                getFieldProps = _nextProps$form.getFieldProps,
                getFieldValue = _nextProps$form.getFieldValue;

            var value = getFieldValue(nextProps.field);
            if ('defaultValue' in nextProps) {
                if (_this.props.defaultValue != nextProps.defaultValue) {
                    _this.setState({ value: nextProps.defaultValue });
                }
            }

            if ('value' in nextProps) {
                if (_this.props.value != nextProps.value) {
                    _this.setState({ value: nextProps.value });
                }
            }
            if (value) {
                _this.setState({ value: value });
            }
        }, _this._onChange = function (value) {
            _this.setState({
                value: value
            });

            var fields = {};
            fields[_this.props.field] = {
                dirty: true,
                errors: undefined,
                name: _this.props.field,
                touched: true,
                validating: true,
                value: value
            };
            _this.props.form.setFields(fields);
            if ((0, _FunctionUtil.isFunction)(_this.props.onChange)) {
                _this.props.onChange(value);
            }
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(YYStepper, [{
        key: 'render',
        value: function render() {
            var getFieldProps = this.props.form.getFieldProps;

            var _props = this.props,
                field = _props.field,
                label = _props.label,
                min = _props.min,
                max = _props.max,
                step = _props.step,
                disabled = _props.disabled,
                defaultValue = _props.defaultValue,
                value = _props.value,
                readOnly = _props.readOnly,
                showNumber = _props.showNumber,
                showIcon = _props.showIcon,
                icon = _props.icon,
                iconColor = _props.iconColor,
                required = _props.required,
                visible = _props.visible,
                restProps = _objectWithoutProperties(_props, ['field', 'label', 'min', 'max', 'step', 'disabled', 'defaultValue', 'value', 'readOnly', 'showNumber', 'showIcon', 'icon', 'iconColor', 'required', 'visible']);

            var requiredMsg = '必填项' + label + '未填写';
            var wrapClz = (0, _classnames2.default)('yy-stepper', !visible && 'hidden', this.props.className);
            return _react2.default.createElement(
                _list2.default.Item,
                _extends({
                    wrap: true
                }, restProps, {
                    className: wrapClz
                }, (0, _FunctionUtil.isFunction)(getFieldProps) ? getFieldProps(field, {
                    initialValue: value,
                    rules: [{ required: required, message: requiredMsg }],
                    valuePropName: 'value'
                }) : null, {
                    extra: _react2.default.createElement(_stepper2.default, {
                        style: { width: '100%', minWidth: '100px' },
                        min: min,
                        max: max,
                        step: step,
                        disabled: disabled,
                        readOnly: readOnly,
                        defaultValue: defaultValue,
                        value: this.state.value,
                        showNumber: true,
                        onChange: this._onChange })
                }),
                showIcon && _react2.default.createElement(_YYIcon2.default, { type: icon, color: iconColor, style: { float: 'left', paddingRight: '8px' }, size: 'xs' }),
                required ? _react2.default.createElement(
                    'span',
                    { className: 'yy-label-required' },
                    label
                ) : label
            );
        }
    }]);

    return YYStepper;
}(_react2.default.Component);

exports.default = YYStepper;


YYStepper.defaultProps = {
    field: 'stepper',
    label: '步进器',
    min: 1,
    max: 100,
    step: 1,
    value: null,
    disabled: false,
    readOnly: false,
    showNumber: true,
    iconColor: "red",
    visible: true,
    required: false
};