'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcTable = require('rc-table');

var _rcTable2 = _interopRequireDefault(_rcTable);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./YYTable.css');

require('rc-table/assets/index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var YYTable = function (_React$Component) {
  _inherits(YYTable, _React$Component);

  function YYTable() {
    _classCallCheck(this, YYTable);

    return _possibleConstructorReturn(this, (YYTable.__proto__ || Object.getPrototypeOf(YYTable)).apply(this, arguments));
  }

  _createClass(YYTable, [{
    key: 'getColumns',
    value: function getColumns(children) {
      var columns = [];
      children.map(function (item, index) {
        var citem = Object.assign({}, item.props, {
          key: item.props.dataIndex,
          className: item.props.titleAlign ? 'yy-table-th-' + item.props.titleAlign : ''
        });
        columns.push(citem);
      });
      return columns;
    }
  }, {
    key: 'onRowClick',
    value: function onRowClick(record, index) {
      if (this.props.onRowClick) {
        this.props.onRowClick(record, index);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          data = _props.data,
          columns = _props.columns,
          bordered = _props.bordered,
          align = _props.align,
          emptyText = _props.emptyText,
          scroll = _props.scroll,
          children = _props.children;

      var wrapClz = (0, _classnames2.default)('yy-table', bordered && 'yy-table-bordered', align === 'center' && 'yy-table-align-center', align === 'right' && 'yy-table-align-right');
      scroll = scroll ? scroll : { x: columns.length > 3 || children && this.getColumns(children).length > 3 ? true : false };
      var devColumn = children && this.getColumns(children).length > 0 ? this.getColumns(children) : [];
      return _react2.default.createElement(
        'div',
        { className: 'yytable-block' },
        _react2.default.createElement(_rcTable2.default, {
          scroll: scroll,
          className: wrapClz,
          columns: columns.length > 0 ? columns : devColumn,
          data: data,
          emptyText: emptyText,
          onRow: function onRow(record, index) {
            return {
              onClick: _this2.onRowClick.bind(_this2, record, index)
            };
          } })
      );
    }
  }]);

  return YYTable;
}(_react2.default.Component);

YYTable.defaultProps = {
  bordered: false,
  align: 'left',
  emptyText: '暂无相关数据',
  data: [],
  columns: [] };

exports.default = YYTable;